;; $Id: cell.scm,v 1.6 1998/09/09 18:36:25 leavens Exp $

;;; Figure 4.5.1 : page 125

(define cell-tag "cell")

(define make-cell
  ; TYPE: (-> (T) (cell T))
  (lambda (x)
    (vector cell-tag x)))

(define cell?
  ; TYPE: (-> (datum) boolean)
  (lambda (x)
    (and (vector? x)
         (= (vector-length x) 2)
         (equal? (vector-ref x 0) cell-tag)))) ; loose check prevents confusion

(define cell-ref
  ; TYPE: (-> ((cell T)) T)
  (lambda (x)
    (if (cell? x)
        (vector-ref x 1)
        (error "Invalid argument to cell-ref: " x))))

(define cell-set!
  ; TYPE: (-> ((cell T) T) void)
  (lambda (x value)
    (if (cell? x) 
        (vector-set! x 1 value)
        (error "Illegal argument to cell-set!: " x))))

(define cell-swap!
  ; TYPE: (-> ((cell T) (cell T)) void)
  (lambda (cell-1 cell-2)
    (let ((temp (cell-ref cell-1)))
      (cell-set! cell-1 (cell-ref cell-2))
      (cell-set! cell-2 temp))))
