;;; $Id: ch6-1-4-expressed-value.scm,v 1.1 1998/11/11 18:02:09 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->expressed
  ;; TYPE: (-> (number) Expressed-Value)
  inject)

(define procedure->expressed
  ;; TYPE: (-> (Procedure) Expressed-Value)
  inject)

(define array->expressed
  ;; TYPE: (-> ((Array Storable-Value)) Expressed-Value)
  inject)

(define list->expressed
  ;; TYPE: (-> ((list Expressed-Value)) Expressed-Value)
  inject)

(define void->expressed
  ;; TYPE: (-> (void) Expressed-Value)
  (lambda (x)
    (number->expressed 0)))

(define ch6-1-4-expressed-value:extract
  ;; TYPE: (-> ((-> (Expressed-Value) boolean) string) (-> (T) T))
  (extract-maker "expressed"))

(define expressed->number
  ;; TYPE: (-> (Expressed-Value) number)
  (ch6-1-4-expressed-value:extract number? "number"))

(define expressed->procedure
  ;; TYPE: (-> (Expressed-Value) Procedure)
  (ch6-1-4-expressed-value:extract (lambda (x) (or (prim-proc? x)
						 (closure? x)))
				 "procedure"))

(define expressed->array
  ;; TYPE: (-> (Expressed-Value) (Array Storable-Value))
  (ch6-1-4-expressed-value:extract array? "array"))

(define expressed->list
  ;; TYPE: (-> (Expressed-Value) (list Expressed-Value))
  (ch6-1-4-expressed-value:extract (lambda (x) (or (pair? x) (null? x)))
				 "list"))
