;;; $Id: ch6-5-2-denoted-value.scm,v 1.1 1998/11/12 22:53:20 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

;;; Anonymous figure : page 202

(define-record thunk (exp env))

(define l-value->denoted
  ;; TYPE: (-> (L-Value) Denoted-Value)
  inject)

;;; *Modified* from Figure 6.5.2 : page 204

(define eval-thunk     ;; name changed from eval-rand, type changed too
  ;; TYPE: (-> ((thunk parsed-exp Environment)) L-value)
  (lambda (thnk)
    (variant-case thnk
      (thunk (exp env)
	(variant-case exp
	  (varref (var) (denoted->l-value (apply-env env var)))
	  (arrayref (array index)
	    (make-ae (expressed->array (eval-array-exp array env))
		     (expressed->number (eval-exp index env))))
	  (else (make-cell (eval-exp exp env)))))
      (else (error "Not a thunk: " thnk)))))

(define denoted->l-value
  ;; TYPE: (-> (Denoted-Value) L-value)
  (lambda (den-val)
    (if (thunk? den-val)
        (eval-thunk den-val) ; changed!
        den-val)))


