;;; $Id: ch6-5-3-denoted-value.scm,v 1.2 1998/12/02 16:22:40 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")
(load-quietly-from-lib "memo.scm")

;;; Anonymous figure : page 202

(define-record thunk (exp env))

(define memo-create
  ;; TYPE: (-> (parsed-exp Environment) Denoted-Value)
  (lambda (exp env)
    (memo-remember
     (lambda ()
       (eval-thunk (make-thunk exp env))))))

;;; *Modified* from Figure 6.5.2 : page 204

(define eval-thunk     ;; name changed from eval-rand, type changed too
  ;; TYPE: (-> ((thunk parsed-exp Environment)) L-value)
  (lambda (thnk)
    (variant-case thnk
      (thunk (exp env)
	(variant-case exp
	  (varref (var) (denoted->l-value (apply-env env var)))
	  (arrayref (array index)
	    (make-ae (expressed->array (eval-array-exp array env))
		     (expressed->number (eval-exp index env))))
	  (else (make-cell (eval-exp exp env)))))
      (else (error "Not a thunk: " thnk)))))

(define l-value->denoted
  ;; TYPE: (-> (L-Value) Denoted-Value)
  inject)

(define denoted->l-value
  ;; TYPE: (-> (Denoted-Value) L-value)
  (lambda (den-val)
    (if (memo? den-val)
	(memo-retrieve den-val)
        den-val)))
