;;; $Id: ch7-1.tst,v 1.1 1998/12/07 02:15:03 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run
"let p = proc (x) x := 5
in let a = 3; 
       b = 4
   in begin
        p(a);
        p(b);
        +(a, b)
      end")
    ==> 7 )
    ( (run
"let stackclass = 
     simpleclass (pushed) (stk, localpushed)
      (initialize = method ()
                      begin
                        &localpushed := 0;
                        &stk := emptylist
                      end;
       empty = method () null(&stk);
       push = method (x)
                begin
                  &&pushed := +(&&pushed, 1);
                  &localpushed := +(&localpushed, 1);
                  &stk := cons(x, &stk)
                end;
       pop = method ()
               if null(&stk)
               then error()
               else begin 
                      &&pushed := -(&&pushed, 1);
                      &localpushed := -(&localpushed, 1);
                      &stk := cdr(&stk)
                    end;
       top = method ()
               if null(&stk)
               then error()
               else car(&stk);
       pushed = method () &&pushed;
       localpushed = method () &localpushed)
      &&pushed := 0
in let stack = simpleinstance stackclass
   in begin
       $push(stack, 7);
       $top(stack)
      end")
      ==> 7)
    ( (run
"let CellClass =
      simpleclass
        () % no class variables
        (value)  % instance variable named value
 	(initialize = method() &value := 0;
         getVal = method() &value;
	 setVal = method(x) &value := x)
         0  % no class variable initialization 
 in let myCell = simpleinstance CellClass
    in begin $setVal(myCell, 3);
             $getVal(myCell)
       end")
      ==> 3)
    ( (run
"let CellClass =
      simpleclass
        () % no class variables
        (value)  % instance variable named value
 	(initialize = method() &value := 0;
         getVal = method() &value;
	 setVal = method(x) &value := x)
         0  % no class variable initialization 
 in let CellWithStatsClass =
  simpleclass
    (callsMade) % class variable
    (value)     % instance variable
    (initialize = method() &value := 0;
     getVal = method()
       begin
         &&callsMade := add1(&&callsMade);
         &value
       end;
     setVal = method(x)
       begin
         &&callsMade := add1(&&callsMade);
         &value := x
       end;
     numCalls = method()
         &&callsMade
    )
    &&callsMade := 0
  in let o = simpleinstance CellWithStatsClass
     in begin $setVal(o, 3);
              let v = $getVal(o)
              in list(v, $numCalls(o))
        end")
      ==> (3 2))
    )
 )
