;;; $Id: ch7-3.tst,v 1.1 1998/12/07 02:15:03 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run
"let p = proc (x) x := 5
in let a = 3; 
       b = 4
   in begin
        p(a);
        p(b);
        +(a, b)
      end")
    ==> 7 )
    ( (run
"let metametacountclass = 
  instance baseobject, baseobject, (classcount)
    (initialize = method () &classcount := 0)
in let metacountclass = 
  instance metametacountclass, baseobject, (instcount)
    (initialize = method () begin 
                              &instcount := 0; 
                              &&classcount := +(&&classcount, 1)
                            end;
     new = method () instance self, baseobject, () ();
     howmany = method () &&classcount)
in let countclass =
  instance metacountclass, baseobject, ()
    (initialize = method () &&instcount := +(&&instcount, 1);
     howmany = method () &&instcount)
in let metastackclass =
  instance classof(metacountclass), metacountclass, (pushed)
    (initialize = method () begin &pushed := 0; $initialize(super) end)
in let stackclass = 
  instance metastackclass, countclass, (stk, localpushed)
    (initialize = method () begin
                              &localpushed := 0;
                              &stk := emptylist;
                              $initialize(super)
                            end;
       empty = method () null(&stk);
       push = method (x)
                begin
                  &&pushed := +(&&pushed, 1);
                  &localpushed := +(&localpushed, 1);
                  &stk := cons(x, &stk)
                end;
       pop = method ()
               if null(&stk)
               then error()
               else begin 
                      &&pushed := -(&&pushed, 1);
                      &localpushed := -(&localpushed, 1);
                      &stk := cdr(&stk)
                    end;
       top = method ()
               if null(&stk)
               then error()
               else car(&stk);
       pushed = method () &&pushed;
       localpushed = method () &localpushed)
in let boundedstackclass = 
  instance classof(stackclass), stackclass, (bound) 
    (initialize = method () begin
                              &bound := 10; 
                              $initialize(super)
                            end;
       push = method (x) 
            if less(&localpushed, &bound)
            then $push(super, x)
            else error();
   setbound = method (x) &bound := x;
   getbound = method () &bound)
in let stackinstance = $new(stackclass);
       boundedstackinstance = $new(boundedstackclass)
   in begin
        $push(stackinstance, 5);
        $push(stackinstance, 6);
        $pop(stackinstance);
        $setbound(boundedstackinstance, 13);
        $push(boundedstackinstance, 3);
        $push(boundedstackinstance, 4);
        $pop(boundedstackinstance);
        list($top(stackinstance),
             $top(boundedstackinstance),
             $getbound(boundedstackinstance),
             $howmany(stackinstance),
             $howmany(boundedstackinstance),
             $pushed(boundedstackinstance),
             $localpushed(boundedstackinstance))
      end")
        ==> (5 3 13 2 2 2 1))
    )
 )
