(define call/cc call-with-current-continuation)
;Value: call/cc

(define *escape/thunk* "any continuation")
;Value: *escape/thunk*

(define escaper
  (lambda (proc)
    (lambda args
      (*escape/thunk*
       (lambda ()
	 (apply proc args))))))
;Value: escaper


(define receiver-4
  (lambda (continuation)
    (set! *escape/thunk* continuation)
    (*escape/thunk* (lambda () (writeln ";escaper is defined")))))
;Value: receiver-4

(define writeln
  (lambda args
    (for-each display args)
    (newline)))
;Value: writeln

((call/cc receiver-4))
escaper is defined
;No value

(*escape/thunk* (lambda() (1+ 6)))
;Value: 7

(+ 5 (*escape/thunk* (lambda() (1+ 6))))
;Value: 7


(let ((receiver (lambda (continuation) 'body)))
  'dots (receiver 'anything) 'dots2)
;Value: dots2


(let ((receiver (lambda (continuation) 'body)))
  'dots (receiver 'anything) 'dots2)
;Value: dots2

(begin
  'dots
  (let ((receiver (escaper (lambda (continuation) 'body))))
    'inner-dots (call/cc receiver) 'inner-dots2)
  'dots2)
;Value: body


(begin
  'dots
  (let ((receiver (escaper (lambda (continuation) 'body))))
    'inner-dots (receiver 'anything) 'inner-dots2)
  'dots2)
;Value: body

(if #t
    2
    (let ((receiver (escaper (lambda (continuation) 'body))))
      (receiver 'anything)))
;Value: 2

(define new-escaper "any-procedure")
;Value: new-escaper


(let ((receiver (lambda (continuation)
		  (set! new-escaper
			(lambda (proc)
			  (lambda args
			    (continuation
			     (lambda ()
			       (apply proc args))))))
		  (lambda () writeln "new-escaper is defined"))))
  ((call/cc receiver)))
;Value: "new-escaper is defined"

new-escaper
;Value: #[compound-procedure 2]
