;;; $Id: decl.scm,v 1.1 1998/10/05 07:52:21 leavens Exp $
;;; Bindings, as in let and letrec
;;; Grammar:
;;;   <(decl T)> ::= ( <var> <T>)
;;;   <var> ::= <symbol>

(define decl?
  ;; TYPE: (-> (datum) boolean)
  (lambda (x)
    (and (list? x)
	 (= (length x) 2)
	 (symbol? (car x)))))

(define make-decl
  ;; TYPE: (-> (symbol T) (decl T))
  list)

(define decl->var
  ;; TYPE: (-> ((decl T)) symbol)
  car)

(define decl->exp
  ;; TYPE: (-> ((decl T)) T)
  cadr)

(define parse-decl-maker
  ;; TYPE: (-> ((-> (datum) T)) (-> (datum) (decl T)))
  (lambda (parse-exp)
    (lambda (exp)
      (cond
       ((decl? exp) (make-decl (car exp) (parse-exp (cadr exp))))
       (else (error "parse-decl: bad syntax in: " exp))))))
