;; $Id: ff-as-record.scm,v 1.5 1998/10/05 08:01:11 leavens Exp $
;; The finite function ADT implemented using records

(load-quietly-from-lib "ribassoc.scm")

;;; Anonymous figure : page 93

(define-record empty-ff ())
(define-record extended-ff (sym val ff))

(define create-empty-ff
  ;; TYPE: (-> () (ff V))
  make-empty-ff)

(define extend-ff
  ;; TYPE: (-> (symbol V (ff V)) (ff V))
  make-extended-ff)

(define-record extended-ff* (sym-list val-vector ff))

(define extend-ff*
  ;; TYPE: (-> ((list symbol) (list V) (ff V)) (ff V))
  (lambda (sym-list val-list ff)
    (make-extended-ff* sym-list (list->vector val-list) ff)))

;;; Anonymous figure : page 96

(define apply-ff
  ;; TYPE: (-> ((ff V) symbol) V)
  (lambda (ff symbol)
    (variant-case ff
      (empty-ff ()
        (error "empty-ff: no association for symbol" symbol))
      (extended-ff (sym val ff)
        (if (eq? symbol sym) 
            val 
            (apply-ff ff symbol)))
      (extended-ff* (sym-list val-vector ff)
        (let ((val (cs342:ribassoc symbol sym-list val-vector '*fail*)))
          (if (eq? val '*fail*)
              (apply-ff ff symbol)
              val)))
      (else (error "apply-ff: Invalid finite function" ff)))))

;;; addition to the book's figures

(define defined-in-ff?
  ;; TYPE: (-> ((ff V) symbol) boolean)
  (lambda (ff symbol)
    (variant-case ff
      (empty-ff () #f)
      (extended-ff (sym ff)
        (if (eq? symbol sym) 
            #t
            (defined-in-ff? ff symbol)))
      (extended-ff* (sym-list val-vector ff)
        (let ((val (cs342:ribassoc symbol sym-list val-vector '*fail*)))
          (if (eq? val '*fail*)
              (defined-in-ff? ff symbol)
              #t)))
      (else (error "defined-in-ff?: Invalid finite function" ff)))))
