;; $Id: monad-base-interpreter.scm,v 1.1 1999/08/11 16:22:54 leavens Exp $

;; Code for EOPL, approximately section 5.1,
;; using the chararacter string parser.

;;; Parsing

;; To use "run", you also need to do
;;        (load "run.scm")
;; To use "read-eval-print", you also need to do
;;        (load "rep.scm")
;; Note that you can't use both of these at the same time.

(load-from-lib "undefine-read-eval-print.scm")
(load-from-lib "undefine-run.scm")
(load-from-lib "ch5-char-parser.scm")

;;; ADTs used

;;; Anonymous figure : page 146

(define true-value?
  ; TYPE: (-> (integer) boolean)
  (lambda (x)
    (not (zero? x))))

(define boolean->int
  ; TYPE: (-> (boolean) integer)
  (lambda (x)
    (if  x  1  0)))

; in the types below, M is the current monad

(define eval-rands
  ; TYPE: (-> ((list parsed-exp)) (M (list Expressed-Value)))
  (lambda (rands)
    (if (null? rands) (return '())
	(bind (eval-exp (car rands))
	      (lambda (head-result)
		(bind (eval-rands (cdr rands))
		      (lambda (rest-of-results)
			(return (cons head-result rest-of-results)))))))))


