;; $Id: monad-ch5-1.scm,v 1.1 1999/08/11 16:22:55 leavens Exp $

;; Code for EOPL sections 5.1-2 using the chararacter string parser and monads,
;; but without varrefs or any environments.

;;; Grammar:
;;	    <exp> ::= <integer-literal>
;;                  | if <exp> then <exp> else <exp>

(load-from-lib "syntax-expand-0.scm")

;;; Top-level Forms
;;      <form> ::= <exp>

(load-from-lib "monad-eval-form-0.scm")

;; the following is needed so read-eval-print works
(define closure? (lambda (x) #f))

;;; Domains for this interpreter:
;;;
;;; Denoted-Value = Expressed-Value
;;; Expressed-Value = Number

;; Monad used: Identity

(load-from-lib "monad-identity.scm")
(define return return-id)
(define bind bind-id)
(define show show-id)

(load-from-lib "monad-base-interpreter.scm")

;;; adapted from Figure 5.1.1 : page 141

(define eval-exp
  ; TYPE: (-> (parsed-exp) (Env Expressed-Value))
  (lambda (exp)
    (variant-case exp
      (lit (datum) (return datum))
      (if (test-exp then-exp else-exp)
	  (bind (eval-exp test-exp)
		(lambda (b)
		  (if (true-value? b)
		      (eval-exp then-exp)
		      (eval-exp else-exp)))))
      (else (error "Invalid abstract syntax:" exp)))))
