;; $Id: record-lambda-1+number-exp-examples.tst,v 1.1 1998/10/07 23:04:36 leavens Exp $

(run-regression-tests-equal?
 `(
    ( (count-varrefs (make-varref 'x)) ==> 1 )
    ( (count-varrefs (make-lit 3)) ==> 0 )
    ( (count-varrefs (make-app (make-varref 'x) (make-varref 'y))) ==> 2 )
    ( (count-varrefs (parse-lambda-1+number-exp '(x y))) ==> 2 )
    ( (count-varrefs (parse-lambda-1+number-exp '(lambda (x) x))) ==> 1 )
    ( (count-varrefs (parse-lambda-1+number-exp '((lambda (x) x) 4)))
      ==> 1 )
    ( (count-varrefs (parse-lambda-1+number-exp '((lambda (x) x) 4))) ==> 1 )
    ( (count-varrefs (parse-lambda-1+number-exp '(f (lambda (x) x)))) ==> 2 )

    ( (all-varrefs (parse-lambda-1+number-exp 'x)) ==> (x) )
    ( (all-varrefs (parse-lambda-1+number-exp '4)) ==> () )
    ( (all-varrefs (parse-lambda-1+number-exp '(x y))) ==> (x y) )
    ( (all-varrefs (parse-lambda-1+number-exp '(lambda (x) y))) ==> (y) )
    ( (all-varrefs (parse-lambda-1+number-exp '((lambda (x) x) 4)))
      ==> (x) )
    ( (all-varrefs (parse-lambda-1+number-exp '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

    ( (subst-varrefs 'new 'old (parse-lambda-1+number-exp 'old))
      = (parse-lambda-1+number-exp 'new) )
    ( (subst-varrefs 'n 'o (parse-lambda-1+number-exp '4))
      = (parse-lambda-1+number-exp 4) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+number-exp '(x y)))
      = (parse-lambda-1+number-exp '(y y)) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+number-exp '(lambda (x) y)))
      = (parse-lambda-1+number-exp '(lambda (x) y)) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+number-exp '((lambda (x) x) 4)))
      = (parse-lambda-1+number-exp '((lambda (x) y) 4)) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+number-exp '(f (lambda (x) (x (f x))))))
      = (parse-lambda-1+number-exp '(f (lambda (x) (y (f y))))) )
    )
 )

