;; $Id: stores.scm,v 1.1 1999/08/11 16:23:01 leavens Exp $

;; A store abstraction, modeled on the environment abstraction (q.v.).

(load-from-lib "ff-as-record.scm")

(define-record State (next store))

(define the-empty-store  ; TYPE: State
  (make-State 0 (create-empty-ff)))

(define extend-store
  ; TYPE: (-> ((list Storable-Value) State) (pair (list Location) State))
  (lambda (svs st)
    (let ((nxt (State->next st))
	  (stor (State->store st)))
      (let ((len-svs (length svs)))
	(let ((new-next (+ len-svs nxt)))
	  (let ((locs ; TYPE: (list Location)
		 (letrec ((list-upto ; TYPE: (-> (Location) (list Location))
			   (lambda (i n)
			     (if (>= i n) '()
				 (cons i (list-upto (+ 1 i) n))))))
		   (list-upto nxt new-next))))
	    (cons locs (make-State new-next (extend-ff* locs svs stor)))))))))

(define assign-store
  ; TYPE: (-> ((list Location) (list Storable-Value) State) State)
  (lambda (locs svs st)
    (let ((nxt (State->next st))
	  (stor (State->store st)))
      (make-State nxt (extend-ff* locs svs stor)))))

(define apply-store
  ; TYPE: (-> (State Location) Storable-Value)
  (lambda (st loc)
    (apply-ff (State->store st) loc)))

(define defined-store?
  ; TYPE: (-> (State Location) boolean)
  (lambda (st loc)
    (defined-ff? (State->store st) loc)))
