;;; $Id: type-check-global-var-types.scm,v 1.15 1999/06/23 16:57:22 leavens Exp $
;;; Types for built-in Scheme procedures
;;; AUTHORS: Curtis Clifton and Gary T. Leavens,
;;;          from an earlier verison by Steven L. Jenkins.


;;; Gary: This was reworked to be an environment of type-expr.
;;;       type-check-precomputed-cxr-types.scm is no longer part
;;;       of the type-checker. - Curt, 5/26/99

(define *tc:global-var-types*
  ;; TYPE: (env symbol type-expr)
  ;;
  ;; Except for the initial quote, and the final right parenthesis
  ;; the following is generated by running the expressions
  ;;  (load "type-check-compute-global-var-types")
  ;;  (pretty-print *tc:pre-global-var-types*)
  ;;
  '
  ((set!
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0)
       #(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr void)))
   (and .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr boolean)
	   #(tc:basic-type-expr ...))
	  #(tc:basic-type-expr boolean)))
   (or .
       #(tc:function-type-expr
	 (#(tc:basic-type-expr boolean)
	  #(tc:basic-type-expr ...))
	 #(tc:basic-type-expr boolean)))
   (delay .
	  #(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:applied-type-expr
	      #(tc:basic-type-expr promise)
	      (#(tc:variable-type-expr ?twn 0)))))
   (not .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr boolean))
	  #(tc:basic-type-expr boolean)))
   (boolean?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (eqv? .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:basic-type-expr boolean)
	       #(tc:basic-type-expr boolean))
	      #(tc:basic-type-expr boolean))
	    #(tc:function-type-expr
	      (#(tc:basic-type-expr number)
	       #(tc:basic-type-expr number))
	      #(tc:basic-type-expr boolean))
	    #(tc:function-type-expr
	      (#(tc:basic-type-expr symbol)
	       #(tc:basic-type-expr symbol))
	      #(tc:basic-type-expr boolean))
	    #(tc:function-type-expr
	      (#(tc:basic-type-expr char)
	       #(tc:basic-type-expr char))
	      #(tc:basic-type-expr boolean)))))
   (eq? .
	#(tc:and-type-expr
	  (#(tc:function-type-expr
	     (#(tc:variable-type-expr ?swn 0)
	      #(tc:variable-type-expr ?swn 0))
	     #(tc:basic-type-expr boolean))
	   #(tc:function-type-expr
	     (#(tc:variable-type-expr ?twn 0)
	      #(tc:basic-type-expr symbol))
	     #(tc:basic-type-expr boolean))
	   #(tc:function-type-expr
	     (#(tc:basic-type-expr symbol)
	      #(tc:variable-type-expr ?uwn 0))
	     #(tc:basic-type-expr boolean)))))
   (equal?
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:variable-type-expr ?swn 0)
	  #(tc:variable-type-expr ?swn 0))
	 #(tc:basic-type-expr boolean))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0)
	  #(tc:basic-type-expr symbol))
	 #(tc:basic-type-expr boolean))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr symbol)
	  #(tc:variable-type-expr ?uwn 0))
	 #(tc:basic-type-expr boolean)))))
   (pair? .
	  #(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:basic-type-expr boolean)))
   (cons .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:variable-type-expr ?swn 0)
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:variable-type-expr ?twn 0)
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?uwn 0))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:basic-type-expr datum))))
	    #(tc:function-type-expr
	      (#(tc:variable-type-expr ?vwn 0)
	       #(tc:variable-type-expr ?wwn 0))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr pair)
		(#(tc:variable-type-expr ?vwn 0)
		 #(tc:variable-type-expr ?wwn 0)))))))
   (car .
	#(tc:and-type-expr
	  (#(tc:function-type-expr
	     (#(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	     #(tc:variable-type-expr ?swn 0))
	   #(tc:function-type-expr
	     (#(tc:applied-type-expr
		#(tc:basic-type-expr pair)
		(#(tc:variable-type-expr ?uwn 0)
		 #(tc:variable-type-expr ?twn 0))))
	     #(tc:variable-type-expr ?uwn 0)))))
   (cdr .
	#(tc:and-type-expr
	  (#(tc:function-type-expr
	     (#(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	     #(tc:applied-type-expr
	       #(tc:basic-type-expr list)
	       (#(tc:variable-type-expr ?swn 0))))
	   #(tc:function-type-expr
	     (#(tc:applied-type-expr
		#(tc:basic-type-expr pair)
		(#(tc:variable-type-expr ?twn 0)
		 #(tc:variable-type-expr ?uwn 0))))
	     #(tc:variable-type-expr ?uwn 0)))))
   (set-car!
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0)))
	  #(tc:variable-type-expr ?swn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0)))
	  #(tc:variable-type-expr ?uwn 0))
	 #(tc:basic-type-expr void)))))
   (set-cdr!
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0)))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0)))
	  #(tc:variable-type-expr ?uwn 0))
	 #(tc:basic-type-expr void)))))
   (null? .
	  #(tc:function-type-expr
	    (#(tc:applied-type-expr
	       #(tc:basic-type-expr list)
	       (#(tc:variable-type-expr ?twn 0))))
	    #(tc:basic-type-expr boolean)))
   (list? .
	  #(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:basic-type-expr boolean)))
   (list .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:variable-type-expr ?twn 0)
	       #(tc:basic-type-expr ...))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?twn 0))))
	    #(tc:function-type-expr
	      (#(tc:basic-type-expr datum)
	       #(tc:basic-type-expr ...))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:basic-type-expr datum)))))))
   (length
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:variable-type-expr ?twn 0))))
      #(tc:basic-type-expr number)))
   (append
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0)))
	  #(tc:basic-type-expr ...))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?twn 0)))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?uwn 0)))
	  #(tc:basic-type-expr ...))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:basic-type-expr datum)))))))
   (reverse
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:variable-type-expr ?twn 0))))
      #(tc:applied-type-expr
	#(tc:basic-type-expr list)
	(#(tc:variable-type-expr ?twn 0)))))
   (list-tail
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:variable-type-expr ?twn 0)))
       #(tc:basic-type-expr number))
      #(tc:applied-type-expr
	#(tc:basic-type-expr list)
	(#(tc:variable-type-expr ?twn 0)))))
   (list-ref
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:variable-type-expr ?twn 0)))
       #(tc:basic-type-expr number))
      #(tc:variable-type-expr ?twn 0)))
   (memq .
	 #(tc:function-type-expr
	   (#(tc:variable-type-expr ?twn 0)
	    #(tc:applied-type-expr
	      #(tc:basic-type-expr list)
	      (#(tc:variable-type-expr ?twn 0))))
	   #(tc:basic-type-expr boolean)))
   (memv .
	 #(tc:function-type-expr
	   (#(tc:variable-type-expr ?twn 0)
	    #(tc:applied-type-expr
	      #(tc:basic-type-expr list)
	      (#(tc:variable-type-expr ?twn 0))))
	   #(tc:basic-type-expr boolean)))
   (member
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0)
       #(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:variable-type-expr ?twn 0))))
      #(tc:basic-type-expr boolean)))
   (assq .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:variable-type-expr ?swn 0)
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:applied-type-expr
		    #(tc:basic-type-expr list)
		    (#(tc:variable-type-expr ?swn 0))))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:variable-type-expr ?twn 0)
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:applied-type-expr
		    #(tc:basic-type-expr pair)
		    (#(tc:variable-type-expr ?twn 0)
		     #(tc:variable-type-expr ?uwn 0))))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr pair)
		(#(tc:variable-type-expr ?twn 0)
		 #(tc:variable-type-expr ?uwn 0)))))))
   (assv .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:variable-type-expr ?swn 0)
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:applied-type-expr
		    #(tc:basic-type-expr list)
		    (#(tc:variable-type-expr ?swn 0))))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:variable-type-expr ?twn 0)
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:applied-type-expr
		    #(tc:basic-type-expr pair)
		    (#(tc:variable-type-expr ?twn 0)
		     #(tc:variable-type-expr ?uwn 0))))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr pair)
		(#(tc:variable-type-expr ?twn 0)
		 #(tc:variable-type-expr ?uwn 0)))))))
   (assoc .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:variable-type-expr ?swn 0)
		#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:applied-type-expr
		     #(tc:basic-type-expr list)
		     (#(tc:variable-type-expr ?swn 0))))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:variable-type-expr ?twn 0)
		#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:applied-type-expr
		     #(tc:basic-type-expr pair)
		     (#(tc:variable-type-expr ?twn 0)
		      #(tc:variable-type-expr ?uwn 0))))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?twn 0)
		  #(tc:variable-type-expr ?uwn 0)))))))
   (symbol?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (symbol->string
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr symbol))
      #(tc:basic-type-expr string)))
   (string->symbol
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr symbol)))
   (number?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (complex?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (real? .
	  #(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:basic-type-expr boolean)))
   (rational?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (integer?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (exact?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (inexact?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (= .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr boolean)))
   (< .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr boolean)))
   (> .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr boolean)))
   (<= .
       #(tc:function-type-expr
	 (#(tc:basic-type-expr number)
	  #(tc:basic-type-expr ...))
	 #(tc:basic-type-expr boolean)))
   (>= .
       #(tc:function-type-expr
	 (#(tc:basic-type-expr number)
	  #(tc:basic-type-expr ...))
	 #(tc:basic-type-expr boolean)))
   (zero? .
	  #(tc:function-type-expr
	    (#(tc:basic-type-expr number))
	    #(tc:basic-type-expr boolean)))
   (negative?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr boolean)))
   (positive?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr boolean)))
   (odd? .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr number))
	   #(tc:basic-type-expr boolean)))
   (even? .
	  #(tc:function-type-expr
	    (#(tc:basic-type-expr number))
	    #(tc:basic-type-expr boolean)))
   (max .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number)
	   #(tc:basic-type-expr number)
	   #(tc:basic-type-expr ...))
	  #(tc:basic-type-expr number)))
   (min .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number)
	   #(tc:basic-type-expr number)
	   #(tc:basic-type-expr ...))
	  #(tc:basic-type-expr number)))
   (+ .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr number)))
   (* .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr number)))
   (- .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr number)))
   (/ .
      #(tc:function-type-expr
	(#(tc:basic-type-expr number)
	 #(tc:basic-type-expr number)
	 #(tc:basic-type-expr ...))
	#(tc:basic-type-expr number)))
   (abs .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number))
	  #(tc:basic-type-expr number)))
   (quotient
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (remainder
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (modulo
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (gcd .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number)
	   #(tc:basic-type-expr ...))
	  #(tc:basic-type-expr number)))
   (lcm .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number)
	   #(tc:basic-type-expr ...))
	  #(tc:basic-type-expr number)))
   (numerator
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (denominator
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (rationalize
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (floor .
	  #(tc:function-type-expr
	    (#(tc:basic-type-expr number))
	    #(tc:basic-type-expr number)))
   (ceiling
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (truncate
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (round .
	  #(tc:function-type-expr
	    (#(tc:basic-type-expr number))
	    #(tc:basic-type-expr number)))
   (exp .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number))
	  #(tc:basic-type-expr number)))
   (log .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number))
	  #(tc:basic-type-expr number)))
   (sin .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number))
	  #(tc:basic-type-expr number)))
   (cos .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number))
	  #(tc:basic-type-expr number)))
   (asin .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr number))
	   #(tc:basic-type-expr number)))
   (acos .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr number))
	   #(tc:basic-type-expr number)))
   (tan .
	#(tc:function-type-expr
	  (#(tc:basic-type-expr number))
	  #(tc:basic-type-expr number)))
   (atan .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:basic-type-expr number))
	      #(tc:basic-type-expr number))
	    #(tc:function-type-expr
	      (#(tc:basic-type-expr number)
	       #(tc:basic-type-expr number))
	      #(tc:basic-type-expr number)))))
   (expt .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr number)
	    #(tc:basic-type-expr number))
	   #(tc:basic-type-expr number)))
   (sqrt .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr number))
	   #(tc:basic-type-expr number)))
   (make-rectangular
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (make-polar
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (real-part
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (imag-part
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (magnitude
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (angle .
	  #(tc:function-type-expr
	    (#(tc:basic-type-expr number))
	    #(tc:basic-type-expr number)))
   (exact->inexact
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (inexact->exact
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (number->string
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr number))
	 #(tc:basic-type-expr string))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr number)
	  #(tc:basic-type-expr number))
	 #(tc:basic-type-expr string)))))
   (string->number
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr string))
	 #(tc:basic-type-expr number))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr string)
	  #(tc:basic-type-expr number))
	 #(tc:basic-type-expr number)))))
   (char? .
	  #(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:basic-type-expr boolean)))
   (char=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char<?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char>?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char<=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char>=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-ci=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-ci<?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-ci>?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-ci<=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-ci>=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-alphabetic?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-numeric?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-whitespace?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-upper-case?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char-lower-case?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr boolean)))
   (char->integer
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr number)))
   (integer->char
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr char)))
   (char-upcase
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr char)))
   (char-downcase
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char))
      #(tc:basic-type-expr char)))
   (string?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (make-string
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr number)
	  #(tc:basic-type-expr char))
	 #(tc:basic-type-expr string))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr number))
	 #(tc:basic-type-expr string)))))
   (string
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr char)
       #(tc:basic-type-expr ...))
      #(tc:basic-type-expr string)))
   (string-length
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr number)))
   (string-ref
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr char)))
   (string-set!
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr number)
       #(tc:basic-type-expr char))
      #(tc:basic-type-expr void)))
   (string=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr ...))
      #(tc:basic-type-expr boolean)))
   (string-ci=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr ...))
      #(tc:basic-type-expr boolean)))
   (string<?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string>?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string<=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string>=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string-ci<?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string-ci>?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string-ci<=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (string-ci>=?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (substring
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr number)
       #(tc:basic-type-expr number))
      #(tc:basic-type-expr string)))
   (string-append
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string)
       #(tc:basic-type-expr ...))
      #(tc:basic-type-expr string)))
   (string->list
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:applied-type-expr
	#(tc:basic-type-expr list)
	(#(tc:basic-type-expr char)))))
   (list->string
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:basic-type-expr char))))
      #(tc:basic-type-expr string)))
   (string-copy
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr string)))
   (string-fill!
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr char)))
   (vector?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (make-vector
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr number)
	  #(tc:variable-type-expr ?swn 0))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr vector)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr number))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr vector)
	   (#(tc:variable-type-expr ?twn 0)))))))
   (vector
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0)
	  #(tc:basic-type-expr ...))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr vector)
	   (#(tc:variable-type-expr ?twn 0))))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr datum)
	  #(tc:basic-type-expr ...))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr vector)
	   (#(tc:basic-type-expr datum)))))))
   (vector-length
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr vector)
	 (#(tc:variable-type-expr ?twn 0))))
      #(tc:basic-type-expr number)))
   (vector-ref
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr vector)
	 (#(tc:variable-type-expr ?twn 0)))
       #(tc:basic-type-expr number))
      #(tc:variable-type-expr ?twn 0)))
   (vector-set!
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr vector)
	 (#(tc:variable-type-expr ?twn 0)))
       #(tc:basic-type-expr number)
       #(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr void)))
   (vector->list
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr vector)
	 (#(tc:variable-type-expr ?twn 0))))
      #(tc:applied-type-expr
	#(tc:basic-type-expr list)
	(#(tc:variable-type-expr ?twn 0)))))
   (list->vector
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:variable-type-expr ?twn 0))))
      #(tc:applied-type-expr
	#(tc:basic-type-expr vector)
	(#(tc:variable-type-expr ?twn 0)))))
   (vector-fill!
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr vector)
	 (#(tc:variable-type-expr ?twn 0)))
       #(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr void)))
   (procedure?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (apply .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?swn 0)
		   #(tc:basic-type-expr ...))
		  #(tc:variable-type-expr ?twn 0))
		#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?uwn 0))
		  #(tc:variable-type-expr ?vwn 0))
		#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?vwn 0))
	     #(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?wwn 0)
		   #(tc:variable-type-expr ?wwn 0))
		  #(tc:variable-type-expr ?xwn 0))
		#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?wwn 0))))
	       #(tc:variable-type-expr ?xwn 0))
	     #(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?ywn 0)
		   #(tc:variable-type-expr ?ywn 0)
		   #(tc:variable-type-expr ?ywn 0))
		  #(tc:variable-type-expr ?zwn 0))
		#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?ywn 0))))
	       #(tc:variable-type-expr ?zwn 0))
	     #(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?awn 0)
		   #(tc:variable-type-expr ?bwn 0)
		   #(tc:variable-type-expr ?cwn 0)
		   #(tc:basic-type-expr ...))
		  #(tc:variable-type-expr ?dwn 0))
		#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?awn 0)
		   #(tc:applied-type-expr
		     #(tc:basic-type-expr pair)
		     (#(tc:variable-type-expr ?bwn 0)
		      #(tc:applied-type-expr
			#(tc:basic-type-expr list)
			(#(tc:variable-type-expr ?cwn 0))))))))
	       #(tc:variable-type-expr ?dwn 0))
	     #(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?ewn 0)
		   #(tc:variable-type-expr ?fwn 0)
		   #(tc:variable-type-expr ?gwn 0)
		   #(tc:variable-type-expr ?hwn 0)
		   #(tc:basic-type-expr ...))
		  #(tc:variable-type-expr ?iwn 0))
		#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?ewn 0)
		   #(tc:applied-type-expr
		     #(tc:basic-type-expr pair)
		     (#(tc:variable-type-expr ?fwn 0)
		      #(tc:applied-type-expr
			#(tc:basic-type-expr pair)
			(#(tc:variable-type-expr ?gwn 0)
			 #(tc:applied-type-expr
			   #(tc:basic-type-expr list)
			   (#(tc:variable-type-expr ?hwn 0))))))))))
	       #(tc:variable-type-expr ?iwn 0))
	     #(tc:function-type-expr
	       (#(tc:function-type-expr
		  (#(tc:variable-type-expr ?jwn 0)
		   #(tc:basic-type-expr ...))
		  #(tc:variable-type-expr ?kwn 0))
		#(tc:variable-type-expr ?jwn 0)
		#(tc:basic-type-expr ...))
	       #(tc:variable-type-expr ?kwn 0)))))
   (map .
	#(tc:and-type-expr
	  (#(tc:function-type-expr
	     (#(tc:function-type-expr
		(#(tc:variable-type-expr ?swn 0))
		#(tc:variable-type-expr ?twn 0))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	     #(tc:applied-type-expr
	       #(tc:basic-type-expr list)
	       (#(tc:variable-type-expr ?twn 0))))
	   #(tc:function-type-expr
	     (#(tc:function-type-expr
		(#(tc:variable-type-expr ?uwn 0)
		 #(tc:variable-type-expr ?vwn 0))
		#(tc:variable-type-expr ?wwn 0))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?uwn 0)))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?vwn 0))))
	     #(tc:applied-type-expr
	       #(tc:basic-type-expr list)
	       (#(tc:variable-type-expr ?wwn 0))))
	   #(tc:function-type-expr
	     (#(tc:function-type-expr
		(#(tc:variable-type-expr ?xwn 0)
		 #(tc:variable-type-expr ?ywn 0)
		 #(tc:variable-type-expr ?zwn 0))
		#(tc:variable-type-expr ?awn 0))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?xwn 0)))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?ywn 0)))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?zwn 0))))
	     #(tc:applied-type-expr
	       #(tc:basic-type-expr list)
	       (#(tc:variable-type-expr ?awn 0))))
	   #(tc:function-type-expr
	     (#(tc:function-type-expr
		(#(tc:variable-type-expr ?bwn 0)
		 #(tc:variable-type-expr ?bwn 0)
		 #(tc:basic-type-expr ...))
		#(tc:variable-type-expr ?cwn 0))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?bwn 0)))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?bwn 0)))
	      #(tc:basic-type-expr ...))
	     #(tc:applied-type-expr
	       #(tc:basic-type-expr list)
	       (#(tc:variable-type-expr ?cwn 0)))))))
   (for-each
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:function-type-expr
	    (#(tc:variable-type-expr ?swn 0))
	    #(tc:basic-type-expr void))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))
	    #(tc:basic-type-expr void))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?twn 0)))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?uwn 0))))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:function-type-expr
	    (#(tc:variable-type-expr ?vwn 0)
	     #(tc:variable-type-expr ?wwn 0)
	     #(tc:variable-type-expr ?xwn 0))
	    #(tc:basic-type-expr void))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?vwn 0)))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?wwn 0)))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?xwn 0))))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:function-type-expr
	    (#(tc:variable-type-expr ?ywn 0)
	     #(tc:basic-type-expr ...))
	    #(tc:basic-type-expr void))
	  #(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?ywn 0)))
	  #(tc:basic-type-expr ...))
	 #(tc:basic-type-expr void)))))
   (force .
	  #(tc:function-type-expr
	    (#(tc:applied-type-expr
	       #(tc:basic-type-expr promise)
	       (#(tc:variable-type-expr ?twn 0))))
	    #(tc:variable-type-expr ?twn 0)))
   (call-with-current-continuation
    .
    #(tc:function-type-expr
      (#(tc:function-type-expr
	 (#(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:basic-type-expr poof)))
	 #(tc:variable-type-expr ?swn 0)))
      #(tc:variable-type-expr ?twn 0)))
   (call/cc
    .
    #(tc:function-type-expr
      (#(tc:function-type-expr
	 (#(tc:function-type-expr
	    (#(tc:variable-type-expr ?twn 0))
	    #(tc:basic-type-expr poof)))
	 #(tc:variable-type-expr ?swn 0)))
      #(tc:variable-type-expr ?twn 0)))
   (call-with-input-file
       .
     #(tc:function-type-expr
       (#(tc:basic-type-expr string)
	#(tc:function-type-expr
	  (#(tc:basic-type-expr port))
	  #(tc:variable-type-expr ?twn 0)))
       #(tc:variable-type-expr ?twn 0)))
   (call-with-output-file
       .
     #(tc:function-type-expr
       (#(tc:basic-type-expr string)
	#(tc:function-type-expr
	  (#(tc:basic-type-expr port))
	  #(tc:variable-type-expr ?twn 0)))
       #(tc:variable-type-expr ?twn 0)))
   (input-port?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (output-port?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (current-input-port
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr port)))
   (current-output-port
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr port)))
   (with-input-from-file
       .
     #(tc:function-type-expr
       (#(tc:basic-type-expr string)
	#(tc:function-type-expr
	  ()
	  #(tc:variable-type-expr ?twn 0)))
       #(tc:variable-type-expr ?twn 0)))
   (with-output-to-file
       .
     #(tc:function-type-expr
       (#(tc:basic-type-expr string)
	#(tc:function-type-expr
	  ()
	  #(tc:variable-type-expr ?twn 0)))
       #(tc:variable-type-expr ?twn 0)))
   (open-input-file
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr port)))
   (open-output-file
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr port)))
   (close-input-port
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr port))
      #(tc:basic-type-expr void)))
   (close-output-port
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr port))
      #(tc:basic-type-expr void)))
   (read .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      ()
	      #(tc:variable-type-expr ?twn 0))
	    #(tc:function-type-expr
	      (#(tc:basic-type-expr port))
	      #(tc:variable-type-expr ?twn 0)))))
   (read-char
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 ()
	 #(tc:basic-type-expr char))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr port))
	 #(tc:basic-type-expr char)))))
   (peek-char
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 ()
	 #(tc:basic-type-expr char))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr port))
	 #(tc:basic-type-expr char)))))
   (eof-object?
    .
    #(tc:function-type-expr
      (#(tc:variable-type-expr ?twn 0))
      #(tc:basic-type-expr boolean)))
   (char-ready?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr port))
      #(tc:basic-type-expr boolean)))
   (write .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:variable-type-expr ?swn 0))
	       #(tc:basic-type-expr void))
	     #(tc:function-type-expr
	       (#(tc:variable-type-expr ?twn 0)
		#(tc:basic-type-expr port))
	       #(tc:basic-type-expr void)))))
   (display
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:variable-type-expr ?swn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0)
	  #(tc:basic-type-expr port))
	 #(tc:basic-type-expr void)))))
   (newline
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 ()
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr port))
	 #(tc:basic-type-expr void)))))
   (write-char
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr char))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr char)
	  #(tc:basic-type-expr port))
	 #(tc:basic-type-expr void)))))
   (load .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr string))
	   #(tc:basic-type-expr void)))
   (transcript-on
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (transcript-off
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr void)))
   (eval .
	 #(tc:function-type-expr
	   (#(tc:basic-type-expr datum))
	   #(tc:variable-type-expr ?twn 0)))
   (error .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       ()
	       #(tc:basic-type-expr poof))
	     #(tc:function-type-expr
	       (#(tc:variable-type-expr ?swn 0))
	       #(tc:basic-type-expr poof))
	     #(tc:function-type-expr
	       (#(tc:variable-type-expr ?twn 0)
		#(tc:variable-type-expr ?uwn 0))
	       #(tc:basic-type-expr poof))
	     #(tc:function-type-expr
	       (#(tc:variable-type-expr ?vwn 0)
		#(tc:variable-type-expr ?wwn 0)
		#(tc:variable-type-expr ?xwn 0))
	       #(tc:basic-type-expr poof))
	     #(tc:function-type-expr
	       (#(tc:variable-type-expr ?ywn 0)
		#(tc:variable-type-expr ?zwn 0)
		#(tc:variable-type-expr ?awn 0)
		#(tc:variable-type-expr ?bwn 0)
		#(tc:basic-type-expr datum)
		#(tc:basic-type-expr ...))
	       #(tc:basic-type-expr poof)))))
   (exit .
	 #(tc:function-type-expr
	   ()
	   #(tc:basic-type-expr poof)))
   (file-exists?
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr boolean)))
   (force-output
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr void)))
   (require
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr symbol))
      #(tc:basic-type-expr void)))
   (verbose
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr void)))
   (quit .
	 #(tc:function-type-expr
	   ()
	   #(tc:basic-type-expr poof)))
   (writeln
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 ()
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?swn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0)
	  #(tc:variable-type-expr ?uwn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?vwn 0)
	  #(tc:variable-type-expr ?wwn 0)
	  #(tc:variable-type-expr ?xwn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?ywn 0)
	  #(tc:variable-type-expr ?zwn 0)
	  #(tc:variable-type-expr ?awn 0)
	  #(tc:variable-type-expr ?bwn 0)
	  #(tc:basic-type-expr datum)
	  #(tc:basic-type-expr ...))
	 #(tc:basic-type-expr void)))))
   (displayln
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 ()
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?swn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0)
	  #(tc:variable-type-expr ?uwn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?vwn 0)
	  #(tc:variable-type-expr ?wwn 0)
	  #(tc:variable-type-expr ?xwn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?ywn 0)
	  #(tc:variable-type-expr ?zwn 0)
	  #(tc:variable-type-expr ?awn 0)
	  #(tc:variable-type-expr ?bwn 0)
	  #(tc:basic-type-expr datum)
	  #(tc:basic-type-expr ...))
	 #(tc:basic-type-expr void)))))
   (load-from-lib
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (load-quietly-from-lib
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (load-quietly
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (random
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr number)))
   (trace .
	  #(tc:function-type-expr
	    (#(tc:basic-type-expr datum)
	     #(tc:basic-type-expr ...))
	    #(tc:basic-type-expr void)))
   (untrace
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr datum)
       #(tc:basic-type-expr ...))
      #(tc:basic-type-expr void)))
   (pretty-print
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr datum))
      #(tc:basic-type-expr void)))
   (*eval-even-if-error*
    .
    #(tc:basic-type-expr boolean))
   (type-prompting-on!
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr void)))
   (type-prompting-off!
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr void)))
   (type-prompting-on?
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr boolean)))
   (type-tracing-set!
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr number))
      #(tc:basic-type-expr void)))
   (type-tracing-off!
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr void)))
   (type-tracing-level
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr number)))
   (type-help
    .
    #(tc:function-type-expr
      ()
      #(tc:basic-type-expr void)))
   (test-hw1
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw2
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw3
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw4
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw5
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw6
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw7
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw8
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw9
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw10
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw11
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (test-hw12
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr string))
      #(tc:basic-type-expr void)))
   (run-test-case-maker
    .
    #(tc:function-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr datum))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr datum))
	 #(tc:basic-type-expr void)))
      #(tc:function-type-expr
	(#(tc:basic-type-expr datum))
	#(tc:basic-type-expr void))))
   (run-test-case
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr datum))
      #(tc:basic-type-expr void)))
   (regression-test-maker
    .
    #(tc:function-type-expr
      (#(tc:function-type-expr
	 (#(tc:variable-type-expr ?swn 0)
	  #(tc:variable-type-expr ?twn 0))
	 #(tc:basic-type-expr boolean))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:variable-type-expr ?twn 0))
	 #(tc:basic-type-expr void)))
      #(tc:function-type-expr
	(#(tc:variable-type-expr ?twn 0)
	 #(tc:basic-type-expr symbol)
	 #(tc:variable-type-expr ?twn 0))
	#(tc:basic-type-expr void))))
   (run-regression-test
    .
    #(tc:function-type-expr
      (#(tc:basic-type-expr scheme-exp)
       #(tc:basic-type-expr symbol)
       #(tc:basic-type-expr datum))
      #(tc:basic-type-expr void)))
   (run-regression-tests-maker
    .
    #(tc:function-type-expr
      (#(tc:function-type-expr
	 (#(tc:basic-type-expr datum)
	  #(tc:basic-type-expr datum))
	 #(tc:basic-type-expr boolean))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr datum))
	 #(tc:basic-type-expr void))
       #(tc:function-type-expr
	 (#(tc:basic-type-expr datum))
	 #(tc:basic-type-expr void)))
      #(tc:function-type-expr
	(#(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:basic-type-expr datum))))
	#(tc:basic-type-expr void))))
   (run-regression-tests-equal?
    .
    #(tc:function-type-expr
      (#(tc:applied-type-expr
	 #(tc:basic-type-expr list)
	 (#(tc:basic-type-expr datum))))
      #(tc:basic-type-expr void)))
   (caar .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:variable-type-expr ?swn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?uwn 0)
		  #(tc:variable-type-expr ?twn 0))))
	      #(tc:variable-type-expr ?uwn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:variable-type-expr ?swn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?uwn 0)
		  #(tc:variable-type-expr ?twn 0))))
	      #(tc:variable-type-expr ?uwn 0)))))
   (cadr .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:variable-type-expr ?swn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?twn 0)
		  #(tc:variable-type-expr ?uwn 0))))
	      #(tc:variable-type-expr ?twn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?twn 0)
		  #(tc:variable-type-expr ?uwn 0))))
	      #(tc:variable-type-expr ?uwn 0)))))
   (cdar .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?uwn 0)
		  #(tc:variable-type-expr ?twn 0))))
	      #(tc:variable-type-expr ?twn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:variable-type-expr ?swn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?uwn 0)
		  #(tc:variable-type-expr ?twn 0))))
	      #(tc:variable-type-expr ?uwn 0)))))
   (cddr .
	 #(tc:and-type-expr
	   (#(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?twn 0)
		  #(tc:variable-type-expr ?uwn 0))))
	      #(tc:variable-type-expr ?uwn 0))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	      #(tc:applied-type-expr
		#(tc:basic-type-expr list)
		(#(tc:variable-type-expr ?swn 0))))
	    #(tc:function-type-expr
	      (#(tc:applied-type-expr
		 #(tc:basic-type-expr pair)
		 (#(tc:variable-type-expr ?twn 0)
		  #(tc:variable-type-expr ?uwn 0))))
	      #(tc:variable-type-expr ?uwn 0)))))
   (caaar .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (caadr .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (cadar .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (caddr .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (cdaar .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (cdadr .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (cddar .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?twn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:variable-type-expr ?swn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?uwn 0)
		   #(tc:variable-type-expr ?twn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (cdddr .
	  #(tc:and-type-expr
	    (#(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr list)
		  (#(tc:variable-type-expr ?swn 0))))
	       #(tc:applied-type-expr
		 #(tc:basic-type-expr list)
		 (#(tc:variable-type-expr ?swn 0))))
	     #(tc:function-type-expr
	       (#(tc:applied-type-expr
		  #(tc:basic-type-expr pair)
		  (#(tc:variable-type-expr ?twn 0)
		   #(tc:variable-type-expr ?uwn 0))))
	       #(tc:variable-type-expr ?uwn 0)))))
   (caaaar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (caaadr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (caadar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (caaddr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cadaar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cadadr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (caddar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cadddr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cdaaar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cdaadr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cdadar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cdaddr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cddaar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cddadr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cdddar
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?twn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:variable-type-expr ?swn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?uwn 0)
	     #(tc:variable-type-expr ?twn 0))))
	 #(tc:variable-type-expr ?uwn 0)))))
   (cddddr
    .
    #(tc:and-type-expr
      (#(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr list)
	    (#(tc:variable-type-expr ?swn 0))))
	 #(tc:applied-type-expr
	   #(tc:basic-type-expr list)
	   (#(tc:variable-type-expr ?swn 0))))
       #(tc:function-type-expr
	 (#(tc:applied-type-expr
	    #(tc:basic-type-expr pair)
	    (#(tc:variable-type-expr ?twn 0)
	     #(tc:variable-type-expr ?uwn 0))))
	 #(tc:variable-type-expr ?uwn 0))))))
  )
