;;; $Id: y.scm,v 1.2 1999/02/11 19:46:45 leavens Exp $

;;; Some fix-point combinators.

;;; The classical (call by name, lazy) fix point combinator.
;;; This won't work in an eager language like Scheme.
(define Y-classical
  ;; TYPE: (-> (-> ((-> (T) T)) (-> (T) T))
  ;;           (-> (T) T))
  (lambda (f)
    ((lambda (x) (f (x x)))
     (lambda (x) (f (x x))))))

;;; Turing's fix-point combinator.
(define theta
  ;; TYPE: (-> (-> ((-> (T) T)) (-> (T) T))
  ;;           (-> (T) T))
  (let ((A (lambda (x) (lambda (y) ((y ((x x) y)))))))
    (A A)))

;;; The following is the call-by-value fix point combinator
;;; (Little Lisper p. 156).
;;; This actually works in Scheme.
(define Y
  ;; TYPE: (-> (-> ((-> (T) T)) (-> (T) T))
  ;;           (-> (T) T))
  (lambda (f)
    ((lambda (x)
       (f (lambda (arg) ((x x) arg))))
     (lambda (x)
       (f (lambda (arg) ((x x) arg)))))))

;;; See the file fix.scm for a more useful fix point procedure for Scheme.

;;; Exercise: generalize Y above so that it also works for multiple arguments.
